[PATCH 1/3] bin/unpack-sources: new helper script for packaging LO

Petr Mladek pmladek at suse.cz
Fri Jul 8 02:54:23 PDT 2011


move the source tarball unpacking from "download" into a separate
script that could be called offline during LO packaging
---
 bin/unpack-sources |  105 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 download           |    9 +----
 2 files changed, 106 insertions(+), 8 deletions(-)
 create mode 100755 bin/unpack-sources

diff --git a/bin/unpack-sources b/bin/unpack-sources
new file mode 100755
index 0000000..153b3ec
--- /dev/null
+++ b/bin/unpack-sources
@@ -0,0 +1,105 @@
+#!/usr/bin/env bash
+
+# Version: MPL 1.1 / GPLv3+ / LGPLv3+
+#
+# The contents of this file are subject to the Mozilla Public License Version
+# 1.1 (the "License"); you may not use this file except in compliance with
+# the License or as specified alternatively below. You may obtain a copy of
+# the License at http://www.mozilla.org/MPL/
+#
+# Software distributed under the License is distributed on an "AS IS" basis,
+# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
+# for the specific language governing rights and limitations under the
+# License.
+#
+# The Initial Developer of the Original Code is
+#       Petr Mladek <pmladek at suse.cz>
+# Portions created by the Initial Developer are Copyright (C) 2011 the
+# Initial Developer. All Rights Reserved.
+#
+# Major Contributor(s): 
+# Ted <ted at bear.com>
+# Portions created by the Ted are Copyright (C) 2010 Ted. All Rights Reserved.
+#
+# For minor contributions see the git repository.
+#
+# Alternatively, the contents of this file may be used under the terms of
+# either the GNU General Public License Version 3 or later (the "GPLv3+"), or
+# the GNU Lesser General Public License Version 3 or later (the "LGPLv3+"),
+# in which case the provisions of the GPLv3+ or the LGPLv3+ are applicable
+# instead of those above.
+
+usage()
+{
+    echo "Helper script to unpack the LO source tarbals"
+    echo
+    echo "Usage: ${0##*/} [--help] start-dir tarball..."
+    echo
+    echo "Options:"
+    echo
+    echo "	--help 		 this help"
+    echo "	start-dir	 path where the sources are unpacked (bootstrap directory)"
+    echo "      tarball          list of LO source tarball that need to be unpacked"
+}
+
+start_dir=
+tarballs=
+
+while test -n "$1" ; do
+    case "$1" in
+	--help)
+	    usage
+	    exit 0;
+	    ;;
+	--download)
+	    download="yes"
+	    ;;
+	-*)
+	    echo "Error: unknown option: $1"
+	    exit 1;
+	    ;;
+	*)
+	    if test -z "$start_dir" ; then
+		start_dir="$1"
+	    else
+	        tarballs="$tarballs $1"
+	    fi
+	    ;;
+    esac
+    shift
+done
+
+if test -z "$start_dir" ; then
+    echo "Error: Please, define where to unpack sources, try --help"
+fi
+
+if ! test -d $start_dir/src -a -f $start_dir/solenv/inc/target.mk ; then
+    echo "Error: $start_dir is not a valid bootstrap directory"
+    exit 1;
+fi
+
+if test ! -f $start_dir/bootstrap.ver -o -d $start_dir/.git ; then
+    echo "Warning: bootstrap sources are from git and not from tarball"
+    echo "         Do nothing."
+    exit 0;
+fi
+
+source $start_dir/bootstrap.ver
+lo_src_dir="$start_dir/src"
+mkdir -p "$lo_src_dir"
+
+for tarball in $tarballs ; do
+    tarname=`basename $tarball | sed -e "s/.tar.bz2//"`
+    if test -d $lo_src_dir/$tarname ; then
+        echo "Warning: $lo_src_dir/$tarname already exists => skipping"
+        continue;
+    fi
+
+    echo "Unpacking $tarname..."
+    tar -xjf "$tarball" -C "$lo_src_dir"
+
+    # create symlinks
+    for dir in `find "$lo_src_dir/$tarname" -mindepth 1 -maxdepth 1 -type d -printf "$tarname/%f\n"` ; do
+        ln -sf "src/$dir" "$start_dir"
+    done
+done
diff --git a/download b/download
index e2c209e..a322936 100755
--- a/download
+++ b/download
@@ -212,14 +212,7 @@ if [ -f $start_dir/bootstrap.ver -a ! -d $start_dir/.git ] ; then
         if [ ! -f "$TARFILE_LOCATION/$tarname.tar.bz2" ] ; then
 	    downloaditem "http://download.documentfoundation.org/libreoffice/src/" "$tarname.tar.bz2" ""
 	fi
-	if [ ! -d $lo_src_dir/$tarname ] ; then
-	    echo "Unpacking $tarname.tar.bz2..."
-	    tar -xf "$TARFILE_LOCATION/$tarname.tar.bz2" -C "$lo_src_dir"
-	fi
-	# create symlinks
-	for dir in `find "$lo_src_dir/$tarname" -mindepth 1 -maxdepth 1 -type d` ; do
-	    ln -sf "$dir" "$start_dir"
-	done
+	$start_dir/bin/unpack-sources $start_dir $TARFILE_LOCATION/$tarname.tar.bz2
     done
 fi
 
-- 
1.7.3.4


--=-FY6SJZIUzbXnJuBxpGHu
Content-Disposition: attachment; filename="bootstrap-0002-add-distro-configs-SUSE-.conf.patch"
Content-Type: text/x-patch; name="bootstrap-0002-add-distro-configs-SUSE-.conf.patch"; charset="UTF-8"
Content-Transfer-Encoding: 7bit



More information about the LibreOffice mailing list